/********************************************************************\

  Name:         util.h
  Created by:   Stefan Ritt

  Contents:     Header file for util.c


  Revision history
  ------------------------------------------------------------------
  date         by    modification
  ---------    ---   ------------------------------------------------
  03-JUL-97    SR    created


\********************************************************************/

double fit(double x[], double y[], double weight[],
           double (*func)(double x, double param[]),
           int n_points, int n_params,
           double param[], double sigmaparam[],
           double yfit[]);

double gauss_fit(double *x, double *y, int n_points, 
                 double param[3], double error[3], int guess_params);

double f_gaussian(double x, double param[]);
double f_gaussexp(double x, double param[]);
double f_trapezoid(double x, double param[]);
double f_2gaussian(double x, double param[]);

void gain_match(float *ref_histo, float *adc_histo, int n,
                float x_low, float x_high,
                float roi_low, float roi_high,
                float range_low, float range_high,
                float *gain, float *error);

void raytrace(int nx, double size_x, int ny, double size_y, int nz, double size_z,
              double x1, double y1, double z1, double x2, double y2, double z2,
              int *n_hit, int *array_i, int *array_j, int *array_k,
              double *array_pathlength);
